Graphics3D 800,600,32,2
SetBuffer BackBuffer()

pxCreateWorld(1,"")

Global cam = CreateCamera()
PositionEntity cam,0,10,-20

plane = CreatePlane()
EntityColor plane,64,128,128

light = CreateLight()

Global ray = pxCreateRay()
HidePointer()
Repeat

control cam : mouselook cam


If MouseHit(1) Then Shoot()

If KeyHit(57) Then CreatepxCube 0,10,0


pxRenderPhysic(60,0)
UpdatepxCubes()

RenderWorld()

Color 200,0,0
Line (GraphicsWidth() Shr 1) - 15, (GraphicsHeight() Shr 1), (GraphicsWidth() Shr 1) + 15, (GraphicsHeight() Shr 1)
Line (GraphicsWidth() Shr 1), (GraphicsHeight() Shr 1) - 15, (GraphicsWidth() Shr 1), (GraphicsHeight() Shr 1) +15
Oval (GraphicsWidth() Shr 1) - 10, (GraphicsHeight() Shr 1)-10, 20,20,0


Flip

Until KeyHit(1)
End

Type pxCube
	Field mesh
	Field body
End Type

Function UpdatepxCubes()
	For pxC.pxCube = Each pxCube
		pxBodySetEntity pxC\mesh, pxC\body
	Next
End Function

Function CreatepxCube.pxCube(x#,y#,z#)
	pxC.pxCube = New pxCube
	pxC\mesh = CreateCube()
	pxC\body = pxBodyCreateCube(1,1,1,1)
	pxBodySetPosition pxC\body,x,y,z
	Return pxC
End Function

Function control(ent) ;   WASD
        If KeyDown(17) MoveEntity ent,0,0,1
        If KeyDown(31) MoveEntity ent,0,0,-1
        If KeyDown(30) MoveEntity ent,-1,0,0
        If KeyDown(32) MoveEntity ent,1,0,0
End Function

Function mouselook(ent) ;   

	mxspd#=MouseXSpeed()*0.25
	myspd#=MouseYSpeed()*0.25

	MoveMouse GraphicsWidth()/2,GraphicsHeight()/2	
	
	campitch#=EntityPitch(ent)+myspd#
	
	If campitch#<-85 Then campitch#=-85 ;  ,         ,    
	If campitch#>85 Then campitch#=85

	RotateEntity ent,campitch#,EntityYaw(ent)-mxspd#,EntityRoll(ent)
End Function

Function Shoot()
	pxRaySetPosition(ray, EntityX(cam,1), EntityY(cam,1),EntityZ(cam,1))
	TFormVector 0,0,1,cam, 0
	DirX# = TFormedX()
	DirY# = TFormedY()
	DirZ# = TFormedZ()
	pxRaySetDir(ray,DirX,DirY,DirZ)
	Body = pxRayGetBody(ray,1)
	If Body Then
		PosX# = pxRayGetPickX(ray, 1)
		PosY# = pxRayGetPickY(ray, 1)
		PosZ# = pxRayGetPickZ(ray, 1)
		pxBodyAddForceAtPos body, DirX*10,DirY*10,DirZ*10, PosX, PosY,PosZ,2
	End If
End Function